VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsINI"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Private mIniFileName As String

Public Property Let FileName(ByVal INIFileName As String)
Attribute FileName.VB_Description = "Set or Get the ini file name,required for working with the file"
'On Error Resume Next
    If Dir(INIFileName, vbNormal) = "" Then
      Open INIFileName For Output As #1
      Close #1
    End If
    mIniFileName = INIFileName
End Property


Public Property Get FileName() As String
'On Error Resume Next
    FileName = mIniFileName
End Property



Public Function GetValue(ByVal Section As String, ByVal Key As String, Optional ByVal DefaultValue As String) As String
Attribute GetValue.VB_Description = "retrive the value of a key in a section"
  On Error GoTo Hell
  Dim Value As String, retval As String, x As Integer
  retval = String$(255, 0)
  x = GetPrivateProfileString(Section, Key, DefaultValue, retval, Len(retval), mIniFileName)
  GetValue = Trim(Left(retval, x))
Exit Function
Hell:
  GetValue = DefaultValue
End Function

Public Function WriteValue(ByVal Section As String, ByVal Key As String, ByVal Value As String) As Boolean
Attribute WriteValue.VB_Description = "Write the valueto the ini file"
  On Error GoTo Hell
  Dim x As Integer
  x = WritePrivateProfileString(Section, Key, Value, mIniFileName)
  If x <> 0 Then WriteValue = True
  Exit Function
Hell:
End Function

Public Function GetAllSections() As Collection
Attribute GetAllSections.VB_Description = "Retrive the list of section in the ini file"
  Dim Value As String, retval As String, x As Integer
  Dim S() As String, i As Integer
  retval = String$(255, 0)
  x = GetPrivateProfileString(vbNullString, "", "", retval, Len(retval), mIniFileName)
  Value = Trim(Left(retval, x))
  S = Split(Value, Chr(0))
  Set GetAllSections = New Collection
  With GetAllSections
    For i = LBound(S) To UBound(S)
      If S(i) <> "" Then .Add S(i)
    Next
  End With
End Function

Public Function GetAllKeys(ByVal Section As String) As Collection
Attribute GetAllKeys.VB_Description = "retrive all the key in the specified section"
  Dim Value As String, retval As String, x As Integer
  Dim S() As String, i As Integer
  retval = String$(255, 0)
  x = GetPrivateProfileString(Section, vbNullString, "", retval, Len(retval), mIniFileName)
  Value = Trim(Left(retval, x))
  S = Split(Value, Chr(0))
  Set GetAllKeys = New Collection
  With GetAllKeys
    For i = LBound(S) To UBound(S)
      If S(i) <> "" Then .Add S(i)
    Next
  End With
End Function

Public Function DeleteSection(ByVal Section As String) As Boolean
Attribute DeleteSection.VB_Description = "Delete all the keys in the specified section"
  On Error GoTo Hell
  Dim x As Integer
  x = WritePrivateProfileString(Section, vbNullString, "", mIniFileName)
  If x <> 0 Then DeleteSection = True
  Exit Function
Hell:
End Function

Public Function DeleteKey(ByVal Section As String, ByVal Key As String) As Boolean
Attribute DeleteKey.VB_Description = "Delete key in the ini file "
  On Error GoTo Hell
  Dim x As Integer
  x = WritePrivateProfileString(Section, Key, vbNullString, mIniFileName)
  If x <> 0 Then DeleteKey = True
  Exit Function
Hell:
End Function
